package de.ozgcloud.apilib.common.command.grpc;

import de.ozgcloud.vorgang.common.GrpcObject;
import de.ozgcloud.vorgang.common.GrpcProperty;
import de.ozgcloud.vorgang.grpc.command.GrpcCommand;

public class GrpcCommandTestFactory {

	public static final GrpcObject BODY_OBJECT = GrpcObject.newBuilder()
		.addProperty(GrpcProperty.newBuilder()
			.setName(OzgCloudCommandTestFactory.BODY_FIELD_NAME).addValue(OzgCloudCommandTestFactory.BODY_FIELD_VALUE))
		.build();

	public static GrpcCommand create() {
		return createBuilder().build();
	}

	public static GrpcCommand.Builder createBuilder() {
		return GrpcCommand.newBuilder()
			.setId(OzgCloudCommandTestFactory.ID.toString())
			.setVorgangId(OzgCloudCommandTestFactory.VORGANG_ID.toString())
			.setCreatedAt(OzgCloudCommandTestFactory.CREATED_AT_STR)
			.setFinishedAt(OzgCloudCommandTestFactory.FINISHED_AT_STR)
			.setCreatedBy(OzgCloudCommandTestFactory.CREATED_BY.toString())
			.setCreatedByName(OzgCloudCommandTestFactory.CREATED_BY_NAME)
			.setStatus(OzgCloudCommandTestFactory.STATUS.toString())
			.setErrorMessage(OzgCloudCommandTestFactory.ERROR_MESSAGE)
			.setRelationId(OzgCloudCommandTestFactory.RELATION_ID.toString())
			.setBodyObj(BODY_OBJECT)
			.setOrderString(OzgCloudCommandTestFactory.ORDER)
			.setCreatedResource(OzgCloudCommandTestFactory.CREATED_RESOURCE);
	}
}
