package de.ozgcloud.apilib.vorgang.grpc;

import static de.ozgcloud.apilib.vorgang.OzgCloudVorgangEingangTestFactory.*;

import de.ozgcloud.vorgang.vorgang.GrpcEingang;
import de.ozgcloud.vorgang.vorgang.GrpcFormData;
import de.ozgcloud.vorgang.vorgang.GrpcFormField;
import de.ozgcloud.vorgang.vorgang.GrpcSubForm;

public class GrpcEingangTestFactory {

	public static GrpcEingang create() {
		return createBuilder().build();
	}

	public static GrpcEingang.Builder createBuilder() {
		return GrpcEingang.newBuilder()
				.setHeader(GrpcEingangHeaderTestFactory.create())
				.setAntragsteller(GrpcAntragstellerTestFactory.create())
				.setZustaendigeStelle(GrpcZustaendigeStelleTestFactory.create())
				.setFormData(createFormData());
	}

	public static GrpcFormData createFormData() {
		return GrpcFormData.newBuilder()
				.addField(GrpcFormField.newBuilder().setName(FIELD_NAME).setLabel(FIELD_LABEL).setValue(FIELD_VALUE).build())
				.addForm(GrpcSubForm.newBuilder().setTitle(SUB_FORM_NAME).setLabel(SUB_FORM_LABEL)
						.addField(GrpcFormField.newBuilder()
								.setName(SUB_FORM_FIELD_NAME)
								.setLabel(SUB_FORM_FIELD_LABEL)
								.setValue(SUB_FORM_FIELD_VALUE).build()))
				.build();
	}
}
